// DlgBgndDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DlgBgnd.h"
#include "DlgBgndDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	virtual ~CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CBitmap m_bmBackground;
	CSize m_sBitmap;
	CBrush m_brHollow;

	//{{AFX_MSG(CAboutDlg)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT

	// Initialize our background bitmap
	VERIFY(m_bmBackground.LoadBitmap(IDB_ABOUTBGND));
	VERIFY(m_brHollow.CreateStockObject(HOLLOW_BRUSH));
	BITMAP bm;
	VERIFY(m_bmBackground.GetBitmap(&bm));
	m_sBitmap = CSize(bm.bmWidth,bm.bmHeight);

}

CAboutDlg::~CAboutDlg()
{
	// Free our bitmap resource
	m_bmBackground.DeleteObject();

}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


BOOL CAboutDlg::OnEraseBkgnd(CDC* pDC) 
{
	CDC dcMem;

	// Build our double buffer
	dcMem.CreateCompatibleDC(pDC);
	CBitmap* pOldBitmap = dcMem.SelectObject(&m_bmBackground);

	// Determine bitmap size.
	const CSize& sBitmap = m_sBitmap;

	// Plaster background (dialog is smaller than the bitmap...
	// I know this because I sized the dialog and bitmap)
	pDC->BitBlt(0,0,sBitmap.cx,sBitmap.cy,&dcMem,0,0,SRCCOPY);

	// Clean up double buffer
	dcMem.SelectObject(pOldBitmap);

    return TRUE; // tell Windows we handled it
}

HBRUSH CAboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	// For the "About" controls, we'll use a transparent brush
	// (allows background bitmap to show through) and set the
	// text color for the text painting.
	pDC->SetBkMode(TRANSPARENT);
	pDC->SetTextColor(RGB(0,0,0)); // black
	return m_brHollow;

}

/////////////////////////////////////////////////////////////////////////////
// CDlgBgndDlg dialog

CDlgBgndDlg::CDlgBgndDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgBgndDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgBgndDlg)
	m_bNormalEdit = TRUE;
	m_iSelBkGnd = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Initialize our background bitmap
	VERIFY(m_bmWood.LoadBitmap(IDB_WOOD));
	VERIFY(m_bmRock.LoadBitmap(IDB_ROCK));
	VERIFY(m_brHollow.CreateStockObject(HOLLOW_BRUSH));
	BITMAP bm;
	VERIFY(m_bmWood.GetBitmap(&bm));
	m_sBitmap = CSize(bm.bmWidth,bm.bmHeight);
	m_pbmCurrent = &m_bmWood;
	m_bDoWood = TRUE;

}

CDlgBgndDlg::~CDlgBgndDlg()
{
	// Free our bitmap resource
	m_bmWood.DeleteObject();
	m_bmRock.DeleteObject();

}

void CDlgBgndDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgBgndDlg)
	DDX_Control(pDX, IDC_LIST1, m_CListBox);
	DDX_Check(pDX, IDC_NORMAL, m_bNormalEdit);
	DDX_Radio(pDX, IDC_WOOD, m_iSelBkGnd);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgBgndDlg, CDialog)
	//{{AFX_MSG_MAP(CDlgBgndDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_NORMAL, OnNormal)
	ON_BN_CLICKED(IDC_WOOD, OnWood)
	ON_BN_CLICKED(IDC_ROCK, OnRock)
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgBgndDlg message handlers

BOOL CDlgBgndDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Initialize our list box
	m_CListBox.AddString("Item 1");
	m_CListBox.AddString("Item 2");
	m_CListBox.AddString("Item 3");
	m_CListBox.AddString("Item 4");
	m_CListBox.AddString("Item 5");
	m_CListBox.AddString("Item 6");
	m_CListBox.AddString("Item 7");
	m_CListBox.AddString("Item 8");
	m_CListBox.AddString("Item 9");
	m_CListBox.AddString("Item 10");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDlgBgndDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDlgBgndDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDlgBgndDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CDlgBgndDlg::OnEraseBkgnd(CDC* pDC) 
{
	CDC dcMem;

	// Build our double buffer
	dcMem.CreateCompatibleDC(pDC);
	CBitmap* pOldBitmap = dcMem.SelectObject(m_pbmCurrent);

	// Determine how large client area is to prepare for 
	// background tiling.
	CRect rcClient;
	GetClientRect(&rcClient);
	const CSize& sBitmap = m_sBitmap;

	// Tile background
	for ( int y = 0; y < rcClient.Height(); y += sBitmap.cy ) {
		for ( int x = 0; x < rcClient.Width(); x += sBitmap.cx ) {
			pDC->BitBlt(x,y,sBitmap.cx,sBitmap.cy,&dcMem,0,0,SRCCOPY);
		} // for
	} // for

	// Clean up double buffer
	dcMem.SelectObject(pOldBitmap);

    return TRUE; // tell Windows we handled it
}

HBRUSH CDlgBgndDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	/*	You may want to see what the erase code would look like
		if I didn't handle your selection logic.  I'd write it
		like this:

	if ((nCtlColor == CTLCOLOR_EDIT) || (nCtlColor == CTLCOLOR_LISTBOX)) {
		// Handle edit and list controls as special
		// cases and disallow their transparency
		return CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
	} // if
	else {
		// Set the new transparent mode
		pDC->SetBkMode(TRANSPARENT);

		// Set the new text color (dark brown in this case)
		pDC->SetTextColor(RGB(64,32,0)); // dk. brown
	} // else

	*/

	// We don't want all controls using a null brush (goofs
	// up the control's paint logic)...
	switch ( nCtlColor ) {
		case CTLCOLOR_EDIT:
		case CTLCOLOR_LISTBOX:
			UpdateData(TRUE); // get check box status
			if ( m_bNormalEdit ) {
				// Handle edit and list controls as special
				// cases and disallow their transparency
				return CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
			} // if
			// else fall thru...

		default:
			pDC->SetBkMode(TRANSPARENT);

			// We'll use a different text color depending upon the
			// chosen background
			if ( m_bDoWood ) {
				// Use a dark brown text color.
				pDC->SetTextColor(RGB(64,32,0)); // dk. brown
			} // if
			else {
				// Use a black text color.
				pDC->SetTextColor(RGB(0,0,0)); // black
			} // else
			break;

	} // switch

	// Return our null brush
	return m_brHollow;

}

void CDlgBgndDlg::OnNormal() 
{
	// We'll redraw the window whenever we change the normal edit
	// setting...
	Invalidate(TRUE);
	
}

void CDlgBgndDlg::OnWood() 
{
	// Set variable
	m_bDoWood = TRUE;

	// Change background setting
	BITMAP bm;
	VERIFY(m_bmWood.GetBitmap(&bm));
	m_sBitmap = CSize(bm.bmWidth,bm.bmHeight);
	m_pbmCurrent = &m_bmWood;

	// We'll redraw the window whenever we change the background
	// setting...
	Invalidate(TRUE);
	
}

void CDlgBgndDlg::OnRock() 
{
	// Set variable
	m_bDoWood = FALSE;

	// Change background setting
	BITMAP bm;
	VERIFY(m_bmRock.GetBitmap(&bm));
	m_sBitmap = CSize(bm.bmWidth,bm.bmHeight);
	m_pbmCurrent = &m_bmRock;

	// We'll redraw the window whenever we change the background
	// setting...
	Invalidate(TRUE);
	
}
